/**
 * 
 */
package at.hl.okb.impl;

import java.util.List;
import java.util.Map;
import java.util.Set;

import com.sun.codemodel.writer.PrologCodeWriter;

import at.hl.okb.ECJConnectorState;
import at.hl.okb.IECJConnector;
import at.hl.okb.wsclient.OKBClientTest;
import at.hl.okb.wsclient.OKBServiceClient;
import at.hl.wsclient.okb.Algorithm;
import at.hl.wsclient.okb.AlgorithmParameter;

/**
 * @author HolperM
 * 
 */
public class ECJ19ConnectorImpl implements IECJConnector {

	private OKBServiceClient okbClient = null;

	/**
	 * 
	 */
	public ECJ19ConnectorImpl() {
		this.okbClient = new OKBServiceClient();
	}
	

	@Override
	public ECJConnectorState initialize(String algorithmName, String platformName, String problemName) throws Exception {

		Long platformId = okbClient.getPlatformId(platformName);
		if (platformId == null)
			throw new Exception("Platform " + platformName + " not found!");

		Long algorithmId = okbClient.getAlgorithmId(algorithmName, platformId);
		if (algorithmId == null)
			throw new Exception("Algorithm " + algorithmName + " for Platform " + platformName + " not found!");

		Long problemId = okbClient.getProblemId(problemName);
		if (problemId == null)
			throw new Exception("Proble " + problemName + " not found!");
		
		return new ECJConnectorState(platformId,algorithmId,problemId);
	}

	@Override
	public void result(ECJConnectorState state, List<Object> resultList, Map<String, Object> algoParams, Map<String, Object> problemParams,
			Object paramFile) throws Exception {
		// TODO Auto-generated method stub
		
		Set<String> missingAlgoParamSet = algoParams.keySet();
		missingAlgoParamSet.removeAll(okbClient.getAlgorithmParameterMap(state.getAlgorithmId()).keySet());
		
		//fehlende Param Anlegen
		if (missingAlgoParamSet.size()>0)
			okbClient.createMissingAlgoParams(state.getAlgorithmId(), missingAlgoParamSet);		
		
		Set<String> missingProblemParamSet = problemParams.keySet();
		missingProblemParamSet.removeAll(okbClient.getProblemParameterMap(state.getProblemId()).keySet());		

		//create Experiment if algoparams not exists in HL and problemparams not exits (in HL)
		//create missing Params in Algo and Problem (if not exits for experiment)
		//create Datatype if missing
		
	}

//	@Override
//	public Map<String, AlgorithmParameter> initializeAlgorithm(
//			String algorithmName, String algorithmClassName, String platformName,
//			Iterable<String> algorithmParameterName) throws Exception {
//		
//		Long platformId = okbClient.getPlatformId(platformName);
//		if (platformId==null)
//			throw new Exception("Platform " + platformName + " not found in HL!");		
//
////		Long algorithmClassId = okbClient.getAlgorithmClassId(algorithmClassName);
////		if (algorithmClassId==null)
////			throw new Exception("AlgorithmClass " + platformName + " not found in HL!");		
//		
//		Long algorithmId = okbClient.getAlgorithmId(algorithmName, /*algorithmClassId*/ platformId);
//		if (algorithmId==null)
//			throw new Exception("Algorithm " + algorithmName + " not found in HL!");
//
//		
//
//		return null;
//		
//	}
}
